"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var react_native_1 = require("react-native");
var classnames_1 = __importDefault(require("../../utils/classnames"));
var styles_1 = __importDefault(require("./styles"));
exports.SplitDecoration = react_1.default.memo(function (props) {
    var computedStyle = classnames_1.default(styles_1.default.diffDecoration, props.style);
    var computedGutterStyle = classnames_1.default(styles_1.default.diffDecorationGutter, props.gutterStyle);
    var computedContentStyle = classnames_1.default(styles_1.default.diffDecorationContent, props.contentStyle);
    // One element spans all gutter and content cells
    if (react_1.default.Children.count(props.children) === 1) {
        return (<react_native_1.View style={computedStyle}>
          <react_native_1.View style={computedContentStyle}>{props.children}</react_native_1.View>
        </react_native_1.View>);
    }
    var _a = props.children, gutter = _a[0], content = _a[1];
    return (<react_native_1.View style={computedStyle}>
        {!props.hideGutter && <react_native_1.View style={computedGutterStyle}>{gutter}</react_native_1.View>}
        <react_native_1.View style={computedContentStyle}>{content}</react_native_1.View>
      </react_native_1.View>);
});
exports.default = exports.SplitDecoration;
//# sourceMappingURL=split_decoration.js.map