"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var react_native_1 = require("react-native");
var context_1 = require("../../context");
var hunk_1 = __importDefault(require("../hunk"));
var Diff = react_1.default.memo(function (props) {
    var diffType = props.diffType, children = props.children, style = props.style, optimizeSelection = props.optimizeSelection, hunks = props.hunks, remainings = __rest(props, ["diffType", "children", "style", "optimizeSelection", "hunks"]);
    var hideGutter = remainings.gutterType === 'none';
    var monotonous = diffType === 'add' || diffType === 'delete';
    var cols = (function (viewType, monotonous) {
        if (viewType === 'unified') {
            return (<react_native_1.View>
            {!hideGutter && <react_native_1.View />}
            {!hideGutter && <react_native_1.View />}
            <react_native_1.View />
          </react_native_1.View>);
        }
        if (monotonous) {
            return (<react_native_1.View>
            {!hideGutter && <react_native_1.View />}
            <react_native_1.View />
          </react_native_1.View>);
        }
        return (<react_native_1.View>
          {!hideGutter && <react_native_1.View />}
          <react_native_1.View />
          {!hideGutter && <react_native_1.View />}
          <react_native_1.View />
        </react_native_1.View>);
    })(props.viewType, monotonous);
    return (<context_1.Provider value={__assign(__assign({}, remainings), { monotonous: monotonous })}>
        <react_native_1.View style={style}>
          {cols}
          {children(hunks)}
        </react_native_1.View>
      </context_1.Provider>);
});
Diff.defaultProps = {
    gutterType: 'default',
    optimizeSelection: false,
    selectedChanges: [],
    widgets: {},
    style: {},
    renderToken: undefined,
    renderGutter: function (_a) {
        var textStyle = _a.textStyle, renderDefault = _a.renderDefault;
        return renderDefault(textStyle);
    },
    children: function (hunks) {
        var key = function (hunk) { return "-" + hunk.oldStart + "," + hunk.oldLines + " +" + hunk.newStart + "," + hunk.newLines; };
        return hunks.map(function (hunk) { return <hunk_1.default key={key(hunk)} hunk={hunk}/>; });
    },
};
exports.default = Diff;
//# sourceMappingURL=index.js.map