"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var react_native_1 = require("react-native");
var CELL_PADDING_VERTICAL = 3;
var CELL_PADDING_HORIZONTAL = 6;
var CELL_FONT_SIZE = 12;
var CODE_FONT_FAMILY = react_native_1.Platform.select({ ios: 'Courier New', android: 'monospace' });
exports.default = react_native_1.StyleSheet.create({
    diffGutter: {
        flex: 0,
        width: 42,
        paddingVertical: CELL_PADDING_VERTICAL,
        paddingHorizontal: CELL_PADDING_HORIZONTAL,
    },
    diffGutterText: {
        fontFamily: CODE_FONT_FAMILY,
        fontSize: CELL_FONT_SIZE,
        textAlign: 'right',
    },
    diffGutterInsert: { backgroundColor: '#d6fedb' },
    diffGutterDelete: { backgroundColor: '#fadde0' },
    diffCodeCell: {
        flex: 1,
        paddingVertical: CELL_PADDING_VERTICAL,
        paddingHorizontal: CELL_PADDING_HORIZONTAL,
    },
    diffCodeCellText: {
        fontFamily: CODE_FONT_FAMILY,
        fontSize: CELL_FONT_SIZE,
    },
    diffCodeCellInsert: { backgroundColor: '#eaffee' },
    diffCodeCellInsertEdit: { backgroundColor: '#c0dc91' },
    diffCodeCellDelete: { backgroundColor: '#fdeff0' },
    diffCodeCellDeleteEdit: { backgroundColor: '#f39ea2' },
    diffUnifiedChange: {
        display: 'flex',
        flexDirection: 'row',
        alignItems: 'stretch',
    },
});
//# sourceMappingURL=styles.js.map