"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var react_native_1 = require("react-native");
var utils_1 = require("../../../utils");
var unified_change_1 = __importDefault(require("./unified_change"));
var unified_widget_1 = __importDefault(require("./unified_widget"));
var groupElements = function (changes, widgets) {
    return changes.reduce(function (elements, change) {
        var key = utils_1.getChangeKey(change);
        elements.push(['change', key, change]);
        var widget = widgets[key];
        if (widget) {
            elements.push(['widget', key, widget]);
        }
        return elements;
    }, []);
};
var renderRow = function (_a, props) {
    var type = _a[0], key = _a[1], value = _a[2];
    var hideGutter = props.hideGutter, selectedChanges = props.selectedChanges, tokens = props.tokens, lineStyle = props.lineStyle, changeProps = __rest(props, ["hideGutter", "selectedChanges", "tokens", "lineStyle"]);
    if (type === 'change') {
        var change = value;
        var side = change.isDelete ? 'old' : 'new';
        var lineNumber = change.isDelete ? utils_1.computeOldLineNumber(value) : utils_1.computeNewLineNumber(value);
        var tokensOfLine = tokens ? tokens[side][lineNumber - 1] : null;
        return (<unified_change_1.default key={"change" + key} style={lineStyle} change={value} hideGutter={hideGutter} selected={selectedChanges.includes(key)} tokens={tokensOfLine} {...changeProps}/>);
    }
    else if (type === 'widget') {
        var element = value;
        return <unified_widget_1.default key={"widget" + key} element={element}/>;
    }
    return null;
};
var UnifiedHunk = react_1.default.memo(function (props) {
    var hunk = props.hunk, widgets = props.widgets, style = props.style, childrenProps = __rest(props, ["hunk", "widgets", "style"]);
    var elements = groupElements(hunk.changes, widgets);
    return <react_native_1.View style={style}>{elements.map(function (element) { return renderRow(element, childrenProps); })}</react_native_1.View>;
});
exports.default = UnifiedHunk;
//# sourceMappingURL=index.js.map