"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var react_native_1 = require("react-native");
var utils_1 = require("../../utils");
exports.renderDefaultBy = function (change, side) { return function (style) {
    var lineNumber = side === 'old' ? utils_1.computeOldLineNumber(change) : utils_1.computeNewLineNumber(change);
    return (<react_native_1.Text style={style} numberOfLines={1}>
      {lineNumber === -1 ? undefined : lineNumber}
    </react_native_1.Text>);
}; };
exports.composeCallback = function (own, custom) {
    if (custom) {
        return function (evt) {
            own(evt);
            custom(evt);
        };
    }
    return own;
};
//# sourceMappingURL=utils.js.map