"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var util_1 = require("../utils/diff/util");
var areNodesMeregable = function (x, y) {
    if (x.type !== y.type) {
        return false;
    }
    if (x.type === 'text') {
        return true;
    }
    if (!x.children || !y.children) {
        return false;
    }
    var xBase = __assign({}, x);
    delete xBase.children;
    var yBase = __assign({}, y);
    delete yBase.children;
    return Object.keys(xBase).every(function (key) {
        return xBase[key] === yBase[key];
    });
};
var mergeNode = function (x, y) {
    if ('value' in x) {
        return __assign(__assign({}, x), { value: x.value + y.value });
    }
    return x;
};
var attachNode = function (parent, node) {
    var previousSibling = util_1.last(parent.children);
    if (previousSibling && areNodesMeregable(previousSibling, node)) {
        parent.children[parent.children.length - 1] = mergeNode(previousSibling, node);
    }
    else {
        parent.children.push(node);
    }
    return util_1.last(parent.children);
};
exports.default = (function (pathList) {
    var root = { type: 'root', children: [] };
    var _loop_1 = function (path) {
        path.reduce(function (parent, node, i) {
            var nodeToUse = i === path.length - 1 ? __assign({}, node) : __assign(__assign({}, node), { children: [] });
            return attachNode(parent, nodeToUse);
        }, root);
    };
    for (var _i = 0, pathList_1 = pathList; _i < pathList_1.length; _i++) {
        var path = pathList_1[_i];
        _loop_1(path);
    }
    return root;
});
//# sourceMappingURL=back_to_tree.js.map