"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var to_token_trees_1 = __importDefault(require("./to_token_trees"));
var normalize_to_lines_1 = __importDefault(require("./normalize_to_lines"));
var back_to_tree_1 = __importDefault(require("./back_to_tree"));
function flow(funcs) {
    var length = funcs ? funcs.length : 0;
    var index = length;
    while (index--) {
        if (typeof funcs[index] !== 'function') {
            throw new TypeError('Expected a function');
        }
    }
    function doFlow() {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        var index = 0;
        var result = length ? funcs[index].apply(this, args) : args[0];
        while (++index < length) {
            result = funcs[index].call(this, result);
        }
        return result;
    }
    return doFlow;
}
exports.tokenize = function (hunks, options) {
    var _a = options.highlight, highlight = _a === void 0 ? false : _a, refractor = options.refractor, oldSource = options.oldSource, language = options.language, _b = options.enhancers, enhancers = _b === void 0 ? [] : _b;
    var tokenTreesPair = to_token_trees_1.default(hunks, { highlight: highlight, refractor: refractor, oldSource: oldSource, language: language });
    var linesOfPathsPair = tokenTreesPair.map(normalize_to_lines_1.default);
    var enhance = flow(enhancers);
    var enhancedLinesOfPathsPair = enhance(linesOfPathsPair);
    var _c = enhancedLinesOfPathsPair.map(function (paths) { return paths.map(back_to_tree_1.default); }), oldTrees = _c[0], newTrees = _c[1];
    return {
        old: oldTrees.map(function (root) { return root.children; }),
        new: newTrees.map(function (root) { return root.children; }),
    };
};
var pick_ranges_1 = require("./pick_ranges");
exports.pickRanges = pick_ranges_1.default;
var mark_edits_1 = require("./mark_edits");
exports.markEdits = mark_edits_1.default;
var mark_word_1 = require("./mark_word");
exports.markWord = mark_word_1.default;
//# sourceMappingURL=index.js.map