"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var utils_1 = require("./utils");
var util_1 = require("../utils/diff/util");
var markInPaths = function (word, name, replacement) { return function (paths) {
    if (!Array.isArray(paths)) {
        return [];
    }
    return paths.reduce(function (acc, path) {
        var leaf = util_1.last(path);
        if (!leaf.value.includes(word)) {
            return [path];
        }
        var segments = leaf.value.split(word);
        acc.push.apply(acc, segments.reduce(function (segmentsAcc, text, i) {
            if (i !== 0) {
                segmentsAcc.push(utils_1.replace(path, { type: 'mark', markType: name, value: replacement }));
            }
            if (text) {
                segmentsAcc.push(utils_1.replace(path, __assign(__assign({}, leaf), { value: text })));
            }
            return segmentsAcc;
        }, []));
        return acc;
    }, []);
}; };
exports.default = (function (word, name, replacement) {
    if (replacement === void 0) { replacement = word; }
    var mark = markInPaths(word, name, replacement);
    return function (_a) {
        var oldLinesOfPaths = _a[0], newLinesOfPaths = _a[1];
        return [oldLinesOfPaths.map(mark), newLinesOfPaths.map(mark)];
    };
});
//# sourceMappingURL=mark_word.js.map