"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var utils_1 = require("./utils");
var util_1 = require("../utils/diff/util");
var treeToPathList = function (node, output, path) {
    if (output === void 0) { output = []; }
    if (path === void 0) { path = []; }
    var nodeToUse = __assign({}, node);
    delete nodeToUse.children;
    if (node.children) {
        path.push(nodeToUse);
        for (var _i = 0, _a = node.children; _i < _a.length; _i++) {
            var child = _a[_i];
            treeToPathList(child, output, path);
        }
        path.pop();
    }
    else {
        output.push(utils_1.clone(__spreadArrays(path.slice(1), [nodeToUse])));
    }
    return output;
};
var splitPathToLines = function (path) {
    var leaf = util_1.last(path);
    if (!leaf.value.includes('\n')) {
        return [path];
    }
    var linesOfText = leaf.value.split('\n');
    return linesOfText.map(function (line) { return utils_1.replace(path, __assign(__assign({}, leaf), { value: line })); });
};
var splitByLineBreak = function (paths) {
    return paths.reduce(function (lines, path) {
        var currentLine = util_1.last(lines);
        var _a = splitPathToLines(path), currentRemaining = _a[0], nextLines = _a.slice(1);
        return __spreadArrays(lines.slice(0, -1), [__spreadArrays(currentLine, [currentRemaining])], nextLines.map(function (path) { return [path]; }));
    }, [[]]);
};
exports.default = (function (tree) {
    var paths = treeToPathList(tree);
    var linesOfPaths = splitByLineBreak(paths);
    return linesOfPaths;
});
//# sourceMappingURL=normalize_to_lines.js.map