"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var util_1 = require("../utils/diff/util");
var utils_1 = require("./utils");
var splitPathToEncloseRange = function (paths, _a) {
    var type = _a.type, start = _a.start, length = _a.length, properties = _a.properties;
    var output = paths.reduce(function (_a, path) {
        var output = _a.output, nodeStart = _a.nodeStart;
        var leaf = util_1.last(path);
        var nodeEnd = nodeStart + leaf.value.length;
        var rangeEnd = start + length;
        if (nodeStart > rangeEnd || nodeEnd < start) {
            output.push(path);
        }
        else {
            var wrapNode = __assign({ type: type }, properties);
            var segments = utils_1.split(path, start - nodeStart, rangeEnd - nodeStart, wrapNode);
            output.push.apply(output, segments);
        }
        return { output: output, nodeStart: nodeEnd };
    }, {
        output: [],
        nodeStart: 0,
    }).output;
    return output;
};
var pickRangesFromPath = function (paths, ranges) {
    if (!ranges || ranges.length === 0) {
        return paths;
    }
    return ranges.reduce(splitPathToEncloseRange, paths);
};
var process = function (linesOfPaths, ranges) {
    var rangesByLine = ranges.reduce(function (acc, range) {
        if (!acc[range.lineNumber]) {
            acc[range.lineNumber] = [];
        }
        acc[range.lineNumber].push(range);
        return acc;
    }, {});
    return linesOfPaths.map(function (line, i) { return pickRangesFromPath(line, rangesByLine[i + 1]); });
};
exports.default = (function (oldRanges, newRanges) { return function (_a) {
    var oldLinesOfPaths = _a[0], newLinesOfPaths = _a[1];
    return [
        process(oldLinesOfPaths, oldRanges),
        process(newLinesOfPaths, newRanges),
    ];
}; });
//# sourceMappingURL=pick_ranges.js.map