"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var util_1 = require("../utils/diff/util");
exports.clone = function (path) { return path.map(function (node) { return (__assign({}, node)); }); };
exports.replace = function (path, leaf) { return __spreadArrays(exports.clone(path.slice(0, -1)), [leaf]); };
exports.wrap = function (path, parent) { return __spreadArrays([parent], exports.clone(path)); };
exports.split = function (path, splitStart, splitEnd, wrapSplitNode) {
    var parents = path.slice(0, -1);
    var leaf = util_1.last(path);
    var output = [];
    if (splitEnd <= 0 || splitStart >= leaf.value.length) {
        return [path];
    }
    var split = function (start, end) {
        var value = leaf.value.slice(start, end);
        return __spreadArrays(parents, [__assign(__assign({}, leaf), { value: value })]);
    };
    if (splitStart > 0) {
        var head = split(0, splitStart);
        output.push(exports.clone(head));
    }
    var body = split(Math.max(splitStart, 0), splitEnd);
    output.push(wrapSplitNode ? exports.wrap(body, wrapSplitNode) : exports.clone(body));
    if (splitEnd < leaf.value.length) {
        var tail = split(splitEnd);
        output.push(exports.clone(tail));
    }
    return output;
};
//# sourceMappingURL=utils.js.map