/// <reference types="react" />
import { IHunk, IChange } from 'gitdiff-parser';
import { TextStyle, ViewStyle } from 'react-native';
export declare type DiffType = 'add' | 'delete' | 'modify' | 'rename' | 'copy';
export declare type Side = 'old' | 'new';
export declare type ViewType = 'unified' | 'split';
export declare type GutterType = 'default' | 'none' | 'anchor';
export declare type Widgets = Record<string, JSX.Element>;
export declare type Events = Record<string, (arg: any) => any>;
export declare type DiffChildren = (hunks: IHunk[]) => JSX.Element | JSX.Element[];
export interface IGutterOptions {
    change: IChange;
    side: Side;
    inHoverState: boolean;
    textStyle?: TextStyle;
    renderDefault: (style?: TextStyle, textStyle?: ViewStyle) => JSX.Element;
}
