"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getChangeKey = function (change) {
    if (!change) {
        throw new Error('change is not provided');
    }
    var isNormal = change.isNormal, isInsert = change.isInsert, lineNumber = change.lineNumber, oldLineNumber = change.oldLineNumber;
    if (isNormal) {
        return 'N' + oldLineNumber;
    }
    var prefix = isInsert ? 'I' : 'D';
    return prefix + lineNumber;
};
//# sourceMappingURL=get_change_key.js.map